#include <iostream>
#include <cassert>
#include <vector>
using namespace std;

int n;

int sljedeci(int i) {
    return (i + 1) % n;
}
int prosli(int i) {
    return (i - 1 + n) % n;
}

int main() {
    cin >> n;
    vector<char> v(n);

    bool allUnknown = true;
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
        if (v[i] != '?') {
            allUnknown = false;
        }
    }
    if (allUnknown) {
        cout << n / 2 << endl;
        return 0;
    }

    bool bad = false;
    for (int i = 0; i < n; ++i) {
        if (v[i] == 'I' && v[sljedeci(i)] == 'I') {
            bad = true;
        }
    }
    if (bad) {
        cout << -1 << endl;
        return 0;
    }

    int sol = 0;
    for (int i = 0; i < n; ++i) {
        sol += v[i] == 'I';
    }
    for (int i = 0; i < n; ++i) {
        if (v[i] == '?' && v[prosli(i)] != '?') {
            int j = sljedeci(i);
            while (v[j] == '?') j = sljedeci(j);
            sol += ((j - i - 1 + n) % n) / 2;
        }
    }
    cout << sol << endl;
}
