#include <iostream>
#include <vector>
using namespace std;

int rokaj(vector<vector<int> > v, int dubina = 0) {
    int n = v.size();
    int m = v[0].size();
    if (dubina == 5) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (v[i][j]) return 1;
            }
        }
        return 0;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (v[i][j]) {
                int res = 999;
                vector<vector<int> > nv = v;
                for (int ni = i; ni < n; ++ni) {
                    nv[ni][j] ^= 1;
                    res = min(res, rokaj(nv, dubina + 1));
                }
                nv = v;
                for (int nj = j; nj < m; ++nj) {
                    nv[i][nj] ^= 1;
                    res = min(res, rokaj(nv, dubina + 1));
                }
                return res + 1;
            }
        }
    }
    return 0;
}

void solve() {
    int n, m; cin >> n >> m;
    vector<vector<int> > v(n, vector<int>(m, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char c; cin >> c;
            if (c == '#' || c == '1') v[i][j] = 1;
        }
    }
    cout << rokaj(v) << endl;
}

int main() {
    int t; cin >> t;
    while (t--) {
        solve();
    }
}
